import react, { startTransition, useEffect, useState } from 'react';
import dispatch from '../../workers/dispatcher-main';
import Trk from './Trk';
import { TileKeyObject, Rectangle } from './types';
import getUri from '../../lib/ids';

export interface GpxProperties {
  id: string;
  keyObject: TileKeyObject;
  zoom: number;
  viewPort: Rectangle;
}

export const Gpx: react.FC<GpxProperties> = (props: GpxProperties) => {
  const [gpx, setGpx] = useState<any>([]);
  useEffect(() => {
    const getGpx = async () => {
      const gpx = await dispatch({
        action: 'getGpx',
        params: {
          id: props.id,
        },
      });
      console.log(`<Gpx>, gpx: ${JSON.stringify(gpx)}`);
      startTransition(() => setGpx(gpx));
    };
    getGpx();
  }, [props.id]);

  return (
    <g>
      {gpx
        .filter((row: any) => row.doc.type === 'trk')
        .map((row: any) => (
          <Trk
            key={row.id}
            id={row.id}
            keyObject={props.keyObject}
            zoom={props.zoom}
            viewPort={props.viewPort}
          />
        ))}
    </g>
  );
};

export default Gpx;
